import numpy as np

class LabSphere(object):
    def __init__(self):

        self.wavelengths_um = [0.350, 0.40, 0.450, 0.5, 0.555, 0.600, 0.655, 0.700, 0.800,
                       0.900, 1.050, 1.150, 1.200, 1.300, 1.540, 1.600, 1.700, 2.00, 2.100, 2.300, 2.400]
        self.Radiance = [1.11, 5.54, 14.7, 26.8, 42.1, 54.0, 66.9, 75.2, 84.1, 93.3, 109,
                    103, 97.2, 92.4, 45.8, 45.1, 40.6, 13.0, 12.3, 8.19, 6.23]

        #convert to nm from um
        self.wavelengths_nm = np.array(self.wavelengths_um)*1e3

        #Calculate the photon energy for each wavelength
        E = self.photon_energy(np.array(self.wavelengths_um)*1e-6)

        # convert to [W cm^-2 sr-1 nm-1] from [W cm^-2 sr-1 um-1]
        self.Radiance_Watts    = np.array(self.Radiance)*1e-3*1e4

        #convert to [photons s-1 cm^-2 sr-1 nm-1]
        self.Radiance_photons = self.Radiance/E

    def photon_energy(self, wavel):
        h = 6.626e-34 #J.s
        c = 2.99e8 #m/s
        E = h*c/wavel #Joules
        return E

# import matplotlib.pyplot as plt
# plt.plot(LabSphere().wavelengths, LabSphere().Radiance)
# plt.xlabel('nm')
# plt.ylabel('W cm^-2 sr-1 nm-1')
# plt.title('LabSphere Port A HES-150 fully open ')
# plt.show()
# print('done')