import numpy as np
from skcomponents.optics.component import OpticalComponent
from skretrieval.core import OpticalGeometry
from sasktran import LineOfSight
import copy


class FrontOptics(OpticalComponent):

    def __init__(self, specs):

        # TODO: Move the PSF integration of the anamorphic optics into this class?

        self.specs = specs
        self.transmission = self.specs.TransFront
        self.wavelength = self.specs.spectrum_wavelengths

    def matrix(self, wavelength):
        return np.eye(4) * self.transmission(wavelength)

    def model_radiance(self, radiance):

        return radiance * self.transmission
